<?php
use Tygh\Registry;
use Tygh\Storage;
use Tygh\Session;
include_once('text/smilepay_text.php');
include_once('smilepay_config.php');

function fn_smilepay_shipping_install()
{
  
    $service_id=db_query("REPLACE INTO ?:shipping_services (status, module, code, sp_file) VALUES ('A', ?s, ?s,'')",SMILEPAY_C2C_SHIPPING_MODULE,SMILEPAY_C2CUP_SHIPPING_CODE);
    if(isset($service_id))
      db_query("REPLACE INTO ?:shipping_service_descriptions (service_id, description , lang_code) VALUES (?i, ?s, 'en');", $service_id,__('smilepayc2c_shipping_711c2cup_desc'));
    else
      db_query("REPLACE INTO ?:shipping_service_descriptions (service_id, description , lang_code) VALUES ((SELECT ?:shipping_services where module=?s AND code=?s limit 1), ?s, 'en');", $service_id,SMILEPAY_C2C_SHIPPING_MODULE,SMILEPAY_C2CUP_SHIPPING_CODE,__('smilepayc2c_shipping_711c2cup_desc'));
    
    $service_id=db_query("REPLACE INTO ?:shipping_services (status, module, code, sp_file) VALUES ('A', ?s, ?s,'')",SMILEPAY_C2C_SHIPPING_MODULE,SMILEPAY_C2CP_SHIPPING_CODE);
    
    if(isset($service_id))
      db_query("REPLACE INTO ?:shipping_service_descriptions (service_id, description , lang_code) VALUES (?i, ?s, 'en');", $service_id,__('smilepayc2c_shipping_711c2c_desc'));
    else
      db_query("REPLACE INTO ?:shipping_service_descriptions (service_id, description , lang_code) VALUES ((SELECT ?:shipping_services where module=?s AND code=?s limit 1), ?s, 'en');", $service_id,SMILEPAY_C2C_SHIPPING_MODULE,SMILEPAY_C2CP_SHIPPING_CODE,__('smilepayc2c_shipping_711c2c_desc'));
}

function fn_smilepay_delete_payment_processors()
{
    //payment del
    $querysql=sprintf("DELETE FROM ?:payment_descriptions WHERE payment_id IN (SELECT payment_id FROM ?:payments WHERE processor_id IN (SELECT processor_id FROM ?:payment_processors WHERE processor_script IN (%s)))",SMILEPAY_PAYMENT_SCRIPT_TABLE);
    db_query($querysql);
    $querysql=sprintf("DELETE FROM ?:payments WHERE processor_id IN (SELECT processor_id FROM ?:payment_processors WHERE processor_script IN (%s))",SMILEPAY_PAYMENT_SCRIPT_TABLE);
    db_query($querysql);
    $querysql=sprintf("DELETE FROM ?:payment_processors WHERE processor_script IN (%s)",SMILEPAY_PAYMENT_SCRIPT_TABLE);
    db_query($querysql);
    
    //shipping del
    $querysql=sprintf("DELETE FROM ?:shippings WHERE service_id IN (SELECT service_id FROM ?:shipping_services WHERE module IN ('%s'))",SMILEPAY_C2C_SHIPPING_MODULE);
    db_query($querysql);
    $querysql=sprintf("DELETE FROM ?:shipping_service_descriptions WHERE service_id IN (SELECT service_id FROM ?:shipping_services WHERE module IN ('%s'))",SMILEPAY_C2C_SHIPPING_MODULE);
    db_query($querysql);
    $querysql=sprintf("DELETE FROM ?:shipping_services WHERE module IN ('%s')",SMILEPAY_C2C_SHIPPING_MODULE);
    db_query($querysql);

    //db_query("DELETE FROM ?:payment_descriptions WHERE payment_id IN (SELECT payment_id FROM ?:payments WHERE processor_id IN (SELECT processor_id FROM ?:payment_processors WHERE processor_script IN ('smilepay.php')))");
    //db_query("DELETE FROM ?:payments WHERE processor_id IN (SELECT processor_id FROM ?:payment_processors WHERE processor_script IN ('smilepay.php'))");
    //db_query("DELETE FROM ?:payment_processors WHERE processor_script IN ('smilepay.php')");
    
    //message table del
    if(!is_null(Registry::get('addons.smilepay.smilepay_payment_record_clear')) && Registry::get('addons.smilepay.smilepay_payment_record_clear') == 'Y')
    {
         db_query("DROP TABLE IF EXISTS `?:smilepay_desc_table`");
    }

}

function fn_smilepay_delete_order($order_id)
{
    /*tmp*/
    //if(isset($order_id) && $_REQUEST['dispatch'] != 'checkout.place_order' ) // order_id = 0 NOT delete avoid fail when place_order
      //db_query("DELETE FROM ?:smilepay_desc_table WHERE smilepay_order_id =". $order_id);
   
}

function fn_smilepay_set_backend_tpl($var)
{
    $smilepay_data_text = array(
        'dcvc' =>TEXT_SMIMEPAY_DCVC,
        'verifykey'=>TEXT_SMIMEPAY_VERIFYKEY,
      /*  'order_created_status' => TEXT_SMIMEPAY_ORDER_CREATED_STATUS,
        'order_failed_status' => TEXT_SMIMEPAY_ORDER_FAILED_STATUS,
        'order_paid_status' => TEXT_SMIMEPAY_ORDER_PAID_STATUS,*/
        'dayline' =>  TEXT_SMIMEPAY_DAYLINE,
    );


    return $smilepay_data_text ;
}
function fn_smilepay_set_backend_order_status_tpl($var)
{

    $statuses=fn_get_statuses(STATUSES_ORDER, array(), false, true);
    $smilepay_data_order_status= array(array());
    $i=0;
     
    foreach($statuses as $status)
    {
        $smilepay_data_order_status[$i]['status']=$status['status'];
        $smilepay_data_order_status[$i++]['description']=$status['description'];
    }
 
  //  $dump=print_r($statuses,true);
  //  file_put_contents("C:\\mytestlog\\test.log", $dump);
    //exit();
    return  $smilepay_data_order_status;
}

//function fn_smilepay_payment_process: Connect to prcess of order of SMSE. 
//argument $url: SMSE's API URL
//argument $postdata: param of SMSE's API
//return: if connect fail return null, if not return result of SMSE's API 
function fn_smilepay_payment_process($url,$postdata)
{
 //   $result = array();
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,$url);
    curl_setopt($ch, CURLOPT_VERBOSE, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
   
    $resultxml=curl_exec($ch); 
    curl_close($ch);
    
   
    if(!is_null( $resultxml) && !empty($resultxml) )
    {
        $xml = simplexml_load_string($resultxml);
        if ($xml) 
        {
            (strlen($xml->PayEndDate) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                     
             $result= array(
                    'AtmBankNo' => strval($xml->AtmBankNo),
                    'AtmNo' => strval($xml->AtmNo),
                    'PayEndDate' =>urlencode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'Barcode1' => strval($xml->Barcode1),
                    'Barcode2' => strval($xml->Barcode2),
                    'Barcode3' => strval($xml->Barcode3),
                    'IbonNo' => strval($xml->IbonNo),
                    'FamiNO' => strval($xml->FamiNO),
                    'SmilePayNO'=>strval($xml->SmilePayNO),
             );   
             return $result;
        }
    }
    return 0;

}


//function fn_smilepay_shipping_process: Connect to prcess of order of SMSE. 
//argument $url: SMSE's API URL
//argument $postdata: param of SMSE's API
//return: if connect fail return null, if not return result of SMSE's API 
function fn_smilepay_shipping_process($url,$postdata)
{
 //   $result = array();
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,$url);
    curl_setopt($ch, CURLOPT_VERBOSE, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
   
    $resultxml=curl_exec($ch); 
    curl_close($ch);
    
   
    if(!is_null( $resultxml) && !empty($resultxml) )
    {
        $xml = simplexml_load_string($resultxml);
        if ($xml) 
        {
            (strlen($xml->PayEndDate) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                     
             $result= array(
                    'PayEndDate' =>urlencode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=>strval($xml->SmilePayNO),
             );   
             return $result;
        }
    }
    return 0;

}


//emap data

function fn_smilepay_get_emap_result_data_after_emap_return()
{
     $data = array(
                    'storeid'=>$_REQUEST['storeid'],
                    'storename'=>$_REQUEST['storename'],
                    'storeaddress'=>$_REQUEST['storeaddress'],
                    'service_type' => $_REQUEST['TempVar'],
                   // 'emap_selected' => '',
             
                ) ;

     return $data;
}

function fn_smilepay_set_emap_result_data_to_session($data)
{
     if(!isset($data))
        return false;

     $_SESSION['smilepay_emap_result'] = $data;
}
function fn_smilepay_get_emap_result_data_from_session()
{
     $data = $_SESSION['smilepay_emap_result'];
     return $data;
}
//emap view data



function fn_smilepay_set_emapview_result_data_to_session($data)
{
     if(!isset($data))
        return false;

     $_SESSION['smilepay_emapview_result'] = $data;
}
function fn_smilepay_get_emapview_result_data_from_session()
{
     $data = $_SESSION['smilepay_emapview_result'];
     return $data;
}


//smse data
function fn_smilepay_get_smse_result_data_after_payment()
{
    $result = array(
              'Classif' => $_REQUEST[ 'Classif'],
              'Classif_sub' => $_REQUEST[ 'Classif_sub'],
              'Od_sob' => $_REQUEST[ 'Od_sob'],
              'Data_id' => $_REQUEST[ 'Data_id'],
              'Process_date' => $_REQUEST[ 'Process_date'],
              'Process_time' => $_REQUEST[ 'Process_time'],
              'Response_id' => $_REQUEST[ 'Response_id'],
              'Auth_code' => $_REQUEST[ 'Auth_code'],
              'Moneytype' => $_REQUEST[ 'Moneytype'],
              'Payment_no' => $_REQUEST[ 'Payment_no'],
              'Purchamt' => $_REQUEST[ 'Purchamt'],
              'Amount' => $_REQUEST[ 'Amount'],
              'Errdesc' => $_REQUEST[ 'Errdesc'],
              'Pur_name' => $_REQUEST[ 'Pur_name'],
              'Tel_number' => $_REQUEST[ 'Tel_number'],
              'Mobile_number' => $_REQUEST[ 'Mobile_number'],
              'Address' => $_REQUEST[ 'Address'],
              'Email' => $_REQUEST[ 'Email'],
              'Invoice_num' => $_REQUEST[ 'Invoice_num'],
              'Remark' => $_REQUEST[ 'Remark'],
              'Smseid' => $_REQUEST[ 'Smseid'],
              'Foreign' => $_REQUEST[ 'Foreign'],
              'Verify_number' => $_REQUEST[ 'Verify_number'],
              'Mid_smilepay' => $_REQUEST[ 'Mid_smilepay'],
        );

        //convert big5 to utf-8
        foreach($result as $key=>$val)
        {
              if(isset($val))
                $result[$key]=iconv("big5","UTF-8",$val);
        }

        

        return $result;
}

function fn_smilepay_get_smse_shipping_result_data_after_payment()
{
    $result = array(
        'Classif' => $_REQUEST['Classif'],
        'Classif_sub' =>$_REQUEST['Classif_sub'],
        'Data_id' => $_REQUEST['Data_id'],
        'Pur_name' => $_REQUEST['Pur_name'],
        'Mobile_number' => $_REQUEST['Mobile_number'],
        'Storeid' =>  $_REQUEST['Storeid'],
        'Storename' => $_REQUEST['Storename'],
        'Storeaddress' => $_REQUEST['Storeaddress'],
        'Amount' => $_REQUEST['Amount'],
        'Smseid' => $_REQUEST['Smseid']
       );
        return $result;
}

function fn_smilepay_set_smse_result_data_to_session($data)
{

    if(!isset($data))
        return false;

   $_SESSION['smilepay_result'] = $data;
   /* $_SESSION['smilepay_AtmBankNo'] =$data['AtmBankNo'];
    $_SESSION['smilepay_AtmNo'] = $data['AtmNo'];
    $_SESSION['smilepay_PayEndDate'] = $data['PayEndDate'];
    $_SESSION['smilepay_Amount'] = $data['Amount'];
    $_SESSION['smilepay_Data_id'] = $data['Data_id'];
    $_SESSION['smilepay_Status'] = $data['Status'];
    $_SESSION['smilepay_Desc'] = $data['Desc'];
    */

    return true;
}

function fn_smilepay_get_smse_result_data_from_session()
{
    //if(is_null($data))
      //  return 0;
        
    $data = $_SESSION['smilepay_result'];
    /*$data['AtmNo']= $_SESSION['smilepay_result']['AtmNo'];
    $data['PayEndDate'] = $_SESSION['smilepay_result']['PayEndDate']  ;
    $data['Amount'] = $_SESSION['smilepay_result']['Amount'];
    $data['Data_id'] = $_SESSION['smilepay_result']['Data_id'];
    $data['Status'] = $_SESSION['smilepay_result']['Status'];
    $data['Desc'] = $_SESSION['smilepay_result']['Desc'];
    $data['Barcode1'] = $_SESSION['smilepay_result']['Barcode1'];
    $data['Barcode2'] = $_SESSION['smilepay_result']['Barcode2'];
    $data['Barcode3'] = $_SESSION['smilepay_result']['Barcode3'];
    $data['IbonNo'] = $_SESSION['smilepay_result']['IbonNo'];
    $data['FamiNO'] = $_SESSION['smilepay_result']['FamiNO'];*/

    return $data;
}
//shipping data
function fn_smilepay_set_smse_shipping_result_data_to_session($data)
{

    if(!isset($data))
        return false;

   $_SESSION['smilepay_result']['shipping'] = $data;

    return true;
}


function fn_smilepay_get_smse_shipping_result_data_from_session()
{
  //  if(is_null($data))
    //    return 0;
        
    $data = $_SESSION['smilepay_result']['shipping'];

    return $data;
}


//clear session
function fn_smilepay_clear_smse_result_data_to_session()
{
    /*unset($_SESSION['smilepay_AtmBankNo']);
    unset($_SESSION['smilepay_AtmNo']);
    unset($_SESSION['smilepay_PayEndDate']);
    unset($_SESSION['smilepay_Amount']);
    unset($_SESSION['smilepay_Data_id']);
    unset($_SESSION['smilepay_Status']);
    unset($_SESSION['smilepay_Desc']);*/
    unset($_SESSION['smilepay_result']);
}
//clear emap session
function fn_smilepay_clear_emap_result_data_to_session()
{
    unset($_SESSION['smilepay_emap_result']);
}
//clear emapview session
function fn_smilepay_clear_emapview_result_data_to_session()
{
    unset($_SESSION['smilepay_emapview_result']);
}

//E-Map is selected?

function fn_smilepay_is_emap_selected()
{
    if(!isset($_SESSION['smilepay_emap_result']['storeid']) || !isset($_SESSION['smilepay_emap_result']['storename']) || !isset($_SESSION['smilepay_emap_result']['storeaddress']) )
    {
        return false;
    }
    return true;
}
//check c2cup emap selected?
function fn_smilepay_is_c2cp_emap_selected()
{
    if(!isset($_SESSION['smilepay_emap_result']['service_type']) || $_SESSION['smilepay_emap_result']['service_type'] != SMILEPAY_C2CP_SHIPPING_CODE)
        return false;
    else
        return fn_smilepay_is_emap_selected();
}

//check c2cup emap selected?
function fn_smilepay_is_c2cup_emap_selected()
{
    if(!isset($_SESSION['smilepay_emap_result']['service_type']) || $_SESSION['smilepay_emap_result']['service_type']  != SMILEPAY_C2CUP_SHIPPING_CODE)
        return false;
    else
        return fn_smilepay_is_emap_selected();
}

// is 711c2cup selected
function fn_smilepay_is_711c2cup_selected($order_id)
{
    if(isset($order_id))
    {
         $order_info=fn_get_order_info($order_id);
         if( $order_info['shipping'][0]['module']==SMILEPAY_C2C_SHIPPING_MODULE &&  $order_info['shipping'][0]['service_code']==SMILEPAY_C2CUP_SHIPPING_CODE)
         {
            return true;
         }
        
    }
    elseif($_SESSION['cart']['shipping'][$_SESSION['cart']['chosen_shipping'][0]]['module']==SMILEPAY_C2C_SHIPPING_MODULE && $_SESSION['cart']['shipping'][$_SESSION['cart']['chosen_shipping'][0]]['service_code']==SMILEPAY_C2CUP_SHIPPING_CODE)
    {
        return true;
    }
    return false;
}
// is 711c2cp selected
function fn_smilepay_is_711c2cp_selected($order_id)
{
    if(isset($order_id))
    {
         $order_info=fn_get_order_info($order_id);
         if( $order_info['shipping'][0]['module']==SMILEPAY_C2C_SHIPPING_MODULE &&  $order_info['shipping'][0]['service_code']==SMILEPAY_C2CP_SHIPPING_CODE)
         {
            return true;
         }
        
    }
    elseif($_SESSION['cart']['shipping'][$_SESSION['cart']['chosen_shipping'][0]]['module']==SMILEPAY_C2C_SHIPPING_MODULE && $_SESSION['cart']['shipping'][$_SESSION['cart']['chosen_shipping'][0]]['service_code']==SMILEPAY_C2CP_SHIPPING_CODE)
    {
        return true;
    }
    return false;
}
// is 711c2cup run once
function fn_smilepay_is_shipping_run()
{
    if(!isset($_SESSION['smilepay_emapview_result']['storeid']) || !isset($_SESSION['smilepay_emapview_result']['storename']) || !isset($_SESSION['smilepay_emapview_result']['storeaddress']) )
    {
        return false;
    }
    return true;
}

// write smilepay comment
function fn_smilepay_fill_comment($order_id,$comment="",$customercanview=0)
{
    $comment=str_replace("'","\\'",$comment);
    $quert_str= sprintf("INSERT INTO ?:smilepay_desc_table (smilepay_order_id , smilepay_desc , smilepay_desc_customer) VALUES (%d , '%s', %d);",$order_id,$comment,$customercanview);
   // $fp = fopen('C:\\mytestlog\\debuglog.log', 'a+');

    //fwrite($fp, $quert_str);
    //fclose($fp);
    db_query( $quert_str); 
}

// get smilepay comment
function fn_smilepay_get_comment_data($order_id,$customercanview=0)
{
    if (!isset($order_id))
      return 0;
    
    $quert_str= sprintf("SELECT smilepay_order_id,smilepay_desc,smilepay_desc_customer,smilepay_timestamp FROM ?:smilepay_desc_table WHERE smilepay_order_id=%d AND smilepay_desc_customer=%d",$order_id,$customercanview);
    //$fp = fopen('C:\\mytestlog\\debuglog.log', 'a+');
    //fwrite($fp, $quert_str);
  
    $result= db_get_array( $quert_str);
    //fwrite($fp, print_r($result,true));
      //fclose($fp);
    //db_query( $quert_str);
    return  $result;
}

//check is payment of smilepay 
function fn_smilepay_is_smilepay_payment($order_id)
{
   

   $smilepay_processor_table = SMILEPAY_PAYMENT_TABLE;
   $order_info = fn_get_order_info($order_id) ;

    
   if(!isset($order_info))
   {
       return false;
   }
   $processor_data= fn_get_processor_data($order_info['payment_id']);
   

   if(!isset($processor_data))
   {
       return false;
   }
   $smilepay_processor_table=explode(",",$smilepay_processor_table);

   foreach($smilepay_processor_table as $smilepay_processor)
   {
       if($smilepay_processor=="")
         continue;
          
       if($smilepay_processor == $processor_data['processor'])
       {

           return true;
       }
   }
   return false;
}
function fn_smilepay_is_smilepay_shipping($order_id)
{
   $order_info = fn_get_order_info($order_id) ;
   $shippingdata= $order_info['shipping'][0];
   if( $shippingdata['module']==SMILEPAY_C2C_SHIPPING_MODULE)
      return true;
   return false;
}
//addons setting 
function fn_smilepay_setting_value_payment_info()
{
   return TEXT_SUCCESS_SMILEPAY_ADDON_PAYMENT_INFO;
}

//mid verification
function fn_smilepay_midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay)
{   
      $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
      $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
      $dtotal=$Mid_value.$Amount.$Smseid;                              
      
      $i = 1;
      $sum = strlen($dtotal);
      $etemp=0;      
      while ($i <= $sum)
      {
        $ep = substr($dtotal,$i,1);
        $etemp = $etemp + $ep;                
        $i=$i+2;
      }                
      
      $i = 0;  
      $otemp=0;          
      while ($i <= $sum)
      {                                              
        $op = substr($dtotal,$i,1);
        $otemp = $otemp + $op;
        $i=$i+2;
      }
      $mid=($etemp*3)+($otemp*9);    
      
      if($Mid_smilepay == $mid){
        return true;
      }else{
        return false;
      }            
}   	


// filter payment for shipping
function fn_smilepay_prepare_checkout_payment_methods(&$cart, &$auth, &$payment_groups)
{
   if(!is_null(Registry::get('addons.smilepay.smilepay_payment_and_shipping_rule')) && Registry::get('addons.smilepay.smilepay_payment_and_shipping_rule') == 'Y') //addon.xml
   {
      
     $smilepay_711c2cp_selected=false;
     $smilepay_711c2cup_selected=false;
     $shipid =array();
     foreach ($cart['shipping'] as $shipping)  // check shipping
     {
       $shipid   =  $shipping['shipping_id'];
       if($shipping['module']==SMILEPAY_C2C_SHIPPING_MODULE && $shipping['service_code']==SMILEPAY_C2CUP_SHIPPING_CODE)
         $smilepay_711c2cup_selected=true;
       elseif($shipping['module']==SMILEPAY_C2C_SHIPPING_MODULE && $shipping['service_code']==SMILEPAY_C2CP_SHIPPING_CODE)
         $smilepay_711c2cp_selected=true;
     }
    


     //filter payment
     foreach ($payment_groups as $gpkey => $group)
     {

       foreach ($group as $pkey => $payment) 
       {
         $payment_data=fn_get_payment_method_data($payment['payment_id']);

         if ($smilepay_711c2cup_selected && $payment_data['processor']== SMILEPAY_711C2C_PAYMENT_PROCESSOR_NAME) 
         {
           unset($payment_groups[$gpkey][$pkey]);
         }
         elseif($smilepay_711c2cp_selected && $payment_data['processor'] != SMILEPAY_711C2C_PAYMENT_PROCESSOR_NAME)
         {
           unset($payment_groups[$gpkey][$pkey]);
         }
         else if(!$smilepay_711c2cup_selected && !$smilepay_711c2cp_selected)
         {
 
           if($payment_data['processor'] == SMILEPAY_711C2C_PAYMENT_PROCESSOR_NAME)
             unset($payment_groups[$gpkey][$pkey]);
         }
      
       }

       if (empty($payment_groups[$gpkey]))
       {
         unset($payment_groups[$gpkey]);
       }
     }



   }
}
function fn_smilepay_checkout_select_default_payment_method(&$cart, &$payment_methods, &$completed_steps)
{
  if(!is_null(Registry::get('addons.smilepay.smilepay_payment_and_shipping_rule')) && Registry::get('addons.smilepay.smilepay_payment_and_shipping_rule') == 'Y') //addon.xml
  {

    $smilepay_711c2cp_selected=false;
    // C2CP selected?
    foreach ($cart['shipping'] as $shipping)
    {
      $shipid   =  $shipping['shipping_id'];
      if($shipping['module']==SMILEPAY_C2C_SHIPPING_MODULE && $shipping['service_code']==SMILEPAY_C2CP_SHIPPING_CODE)
        $smilepay_711c2cp_selected=true;
    }

    if($smilepay_711c2cp_selected)
    {
      foreach ($payment_methods as $payment_group) 
      {
        foreach ($payment_group as $payment_method) 
        {
          //select default C2CP payment 
          $payment_data=fn_get_payment_method_data($payment_method['payment_id']);
          if($payment_data['processor']==SMILEPAY_711C2C_PAYMENT_PROCESSOR_NAME)
          {
            $cart['payment_id'] = $payment_data['payment_id'];
            $cart['payment_method_data'] = fn_get_payment_method_data($cart['payment_id']);
          }
        }
      }
    }
    else
    {
      //default select is C2CP payment
      // set last group first payment
      if($cart['payment_method_data']['processor'] == SMILEPAY_711C2C_PAYMENT_PROCESSOR_NAME)
      {
        foreach ($payment_methods as $payment_group) 
        {
          foreach ($payment_group as $payment_method) 
          {
            $payment_data=fn_get_payment_method_data($payment_method['payment_id']);
            $cart['payment_id'] = $payment_data['payment_id'];
            $cart['payment_method_data'] = fn_get_payment_method_data($cart['payment_id']);
            break;
          }

         }
       }
     
    }

  }
  
}




?>